/*
 * $LastChangedRevision: 3952 $
 * $LastChangedDate:: 2025-11-27 21:04:55 +0100#$
 *
 * This file is part of X2C. web: x2c.lcm.at
 *
 * Copyright (c) 2024, Linz Center of Mechatronics GmbH (LCM), web: x2c.lcm.at
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
 *       the names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include <DAVE.h>
#include "TableStruct.h"
#include "LNet.h"
#include "Services.h"
#include "BlockServices.h"
#include "ServicesModelIdentifier.h"
#include "CommonFcts.h"
#include "VersionInfo.h"
#include "GlobalDefines.h"
#include "Hardware.h"
#include "InterruptControl.h"
#include "X2CCode/X2C.h"
#include "Main.h"

#define APPLICATION_VERSION ((uint16)1)

/* X2C maintenance structure */
volatile tTableStruct TheTableStruct;
volatile tTableStruct* TableStruct = &TheTableStruct;

/* LNet protocol buffersize & node identifier */
#define LNET_BUFFERSIZE ((uint16)256+6)
#define LNET_NODEID ((uint8)1)

static tSerial interface;
static tLNet protocol;
static uint8 bufferLNet[LNET_BUFFERSIZE];

/**

 * @brief main() - Application entry point
 *
 * <b>Details of function</b><br>
 * This routine is the application entry point. It is invoked by the device startup code. It is responsible for
 * invoking the APP initialization dispatcher routine - DAVE_Init() and hosting the place-holder for user application
 * code.
 */
int main(void)
{
	DAVE_STATUS_t status;

	/* Initialization of DAVE APPs  */
	status = DAVE_Init();
	if(status == DAVE_STATUS_FAILURE)
	{
		/* Placeholder for error handler code. The while loop below can be replaced with an user error handler. */
		XMC_DEBUG("DAVE APPs initialization failed\n");

		while(1U)
		{
			;
		}
	}

	/** - Initialize "integrated bootloader":
	 *    - configuration of LNet protocol:
	 *      - Node-ID: 1
	 *      - Buffer size: 255
	 *      .
	 *    .
	 *  - Initialize serial interface
	 */
	initTableStruct();
	initSerial(&interface, &UART_0);
	initLNet(&protocol, bufferLNet, LNET_BUFFERSIZE, LNET_NODEID);
	initServiceTable((tProtocol*)&protocol);
	addCoreServices((tProtocol*)&protocol);
	addBlockServices((tProtocol*)&protocol);
	addModelIdentifierServices((tProtocol*)&protocol);
	addTableStructProtocol((tProtocol*)&protocol);
	linkSerial((tProtocol*)&protocol, &interface);

	initVersionInfo(TableStruct, APPLICATION_VERSION);
	TableStruct->DSPState = PRG_LOADED_STATE;

	/** - Initialize X2C */
	X2C_Init();

	/** - Initialize hardware */
	initHardware();
	KICK_DOG;

	/** - Initialize CPU load measurement */
	CPU_Scale = TIMER_0.ccu4_slice_ptr->PRS;

    /** - Never ending loop -> interrupt driven algorithm */
    while(1)
	{
		/* communication procedure */
		protocol.communicate((tProtocol*)&protocol);
	}
}

/**
 * @brief Main control task.
 *
 * The main control task is called by the ADC interrupt service routine with a frequency of 10kHz.
 */
void mainTask(void)
{
	/** - Assign inports */
	x2cModel.inports.bButton1 = (bool)XMC_GPIO_GetInput(P15_13);
	x2cModel.inports.bButton2 = (bool)XMC_GPIO_GetInput(P15_12);

	/** - Update X2C */
	X2C_Update();

	/** - Update outports */
    if (*x2cModel.outports.bLED1)
    {
    	XMC_GPIO_SetOutputHigh(P5_9);
    }
    else
    {
    	XMC_GPIO_SetOutputLow(P5_9);
    }
    if (*x2cModel.outports.bLED2)
    {
    	XMC_GPIO_SetOutputHigh(P5_8);
    }
    else
    {
    	XMC_GPIO_SetOutputLow(P5_8);
    }

    /* - Reset watchdog timer */
	KICK_DOG;
}
